#include <stdio.h>
#include <assert.h>
#include <map>
#include <string.h>

#include "lib.h"

#define MAXK 100000
#define MAXL 100000

int main(int argc, char **argv)
{
	assert(argc==4);

	FILE *fin = fopen(argv[1],"r");
	FILE *fres = fopen(argv[2],"r");
	FILE *fout = fopen(argv[3],"r");

	char key[MAXK];
	char line[MAXL];

	int K,N;
	fscanf(fin, "%d %d", &K, &N);

	std::map<std::string, int> freqs;
	for (int i=0; i<N; i++) {
		char buf[100];
		int count;
		fscanf(fin, "%s %d", buf, &count);
		freqs[buf] = count;
	}

	fscanf(fin, "%s", line);

	fscanf(fres, "%s", key);

	std::string orig = decode(key, line);

	int weight;
	fscanf(fout, "%d", &weight);
	
	int result = 0;
	
	printf("%d %d w:%d\n", strlen(key), orig.c_str(), get_weight(orig,freqs));
	//printf("%d %s %s %d\n", strlen(key), key, orig.c_str(), get_weight(orig, freqs));


	if (strlen(key) != K || weight != get_weight(orig, freqs))
		result = 1;

	fclose(fin);
	fclose(fres);
	fclose(fout);

	return result;
}
