#include <stdio.h>
#include <string>
#include <string.h>

#define MAXK	50000
#define MAXL	50000

#define ALPHABET_SIZE ('Z'-'A'+1)

int K, N, len;
char line[MAXL+1];

int freqs[ALPHABET_SIZE][ALPHABET_SIZE] = {0};

int freq(int index, char first, char second)
{
	int result = 0;
	for (int i=index; i<len-1; i+=K) {
		result += freqs[(line[i]-'A'-(first)+ALPHABET_SIZE)%ALPHABET_SIZE][(line[i+1]-'A'-(second)+ALPHABET_SIZE)%ALPHABET_SIZE];
	}
	return result;
}

int table[2][ALPHABET_SIZE][ALPHABET_SIZE];
char pred[MAXK+2][ALPHABET_SIZE][ALPHABET_SIZE];

int current = 0, prev = 1;

int main()
{
	FILE *fin = stdin;

	scanf("%d%d", &K, &N);

	for (int i=0; i<N; i++) {
		char pair[100];
		int tmp;
		fscanf(fin, "%s%d", pair, &tmp);
		freqs[pair[0]-'A'][pair[1]-'A'] = tmp;
	}

	scanf("%s", line);
	len = strlen(line);
	
	for (int i=0; i<ALPHABET_SIZE; i++) {
		for (int j=0; j<ALPHABET_SIZE; j++) {
			table[current][i][j] = i==j?0:-1;
		}
	}
	
	for (int i=2; i<=K+1; i++) {
		std::swap(current, prev);
	
		for (int x=0; x<ALPHABET_SIZE; x++) {
			for (int y=0; y<ALPHABET_SIZE; y++) {
				int max = -1;
				char maxz;
				for (int z=0; z<ALPHABET_SIZE; z++) {
					if (table[prev][x][z] >= 0) {
						int t = table[prev][x][z] + freq(i-2, z, y);
						if (t > max) {
							max = t;
							maxz = z;
						}
					}
				}
				table[current][x][y]=max;
				pred[i][x][y] = maxz;
			}
		}
	}
	
	int max = -1;
	int maxz;
	for (int z=0; z<ALPHABET_SIZE; z++) {
		if (table[current][z][z] > max) {
			max = table[current][z][z];
			maxz = z;
		}
	}

	std::string result;

	int j = maxz;
	for (int i=K+1; i>=2; i--) {
		j = pred[i][maxz][j];
		result.push_back(j+'A');
	}

	for (int i=K-1; i>=0; i--) {
		putchar(result[i]);
	}
	putchar('\n');
}
